# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin

try:
    from urlparse import parse_qs
except ImportError:
    from urllib.parse import parse_qs
import sys
import requests
from requests.compat import urlencode, urlparse

if sys.version_info < (2, 7) or (sys.version_info >= (3, 0) and sys.version_info < (3, 1)):
    import simplejson as json
    from simplejson import OrderedDict
else:
    import json
    from collections import OrderedDict
import haitum


def item(title, para, isFolder=True):
    listitem = xbmcgui.ListItem(title)
    if 'title' not in para:
        para['title'] = title
    for k in para:
        if isinstance(para[k], unicode):
            para[k] = para[k].encode('utf-8')
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(para), listitem, isFolder)


def play(title, url, header={}):
    listitem = xbmcgui.ListItem(title)
    h = []
    if header:
        url += '|' + urlencode(header)
    xbmc.Player().play(url, listitem)


def sub1(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.path[-5:] == '.m3u8':
        return False
    if l > 1 and p[1] == 'share':
        return False
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.path[-5:] == '.m3u8':
        play('', url)
        return
    if o.netloc == 'www.haitum.com':
        if l < 3:
            xbmcgui.Dialog().ok('错误', '错误代码: haitum 021')
            return
        if p[1] != 'movie':
            xbmcgui.Dialog().ok('错误', '错误代码: haitum 022')
            return
        if 'index' in q:
            index = int(q['index'][0])
        else:
            index = -1
        ret = haitum.movie(url, index)
    elif l > 1 and p[1] == 'share':
        xbmcgui.Dialog().ok('错误', '还没做 而且不打算做 换别的线路看吧')
        return
    else:
        xbmcgui.Dialog().ok('错误', '错误代码: haitum 020')
        return
    if 'code' in ret:
        xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
        return
    if 'item' in ret:
        for elem in ret['item']:
            item(elem['title'], elem, sub1(elem['url']))
        xbmcplugin.endOfDirectory(handle)
    if 'url' in ret:
        if 'header' in ret:
            play('', ret['url']['m3u8'], ret['header'])
        else:
            play('', ret['url']['m3u8'])


def sub3(content):
    try:
        data = json.loads(content, object_pairs_hook=OrderedDict)
    except:
        xbmcgui.Dialog().ok('错误', '错误代码: haitum 030')
        return
    for k in data:
        if isinstance(data[k], dict):
            item(k, {'json': json.dumps(data[k])})
        else:
            url = data[k]
            item(k, {'url': url}, sub1(url))
    xbmcplugin.endOfDirectory(handle)


def category(category, page):
    ret = haitum.category(category, page)
    if 'code' in ret:
        xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
        return
    for elem in ret['item']:
        item(elem['title'], elem)
    xbmcplugin.endOfDirectory(handle)


def search():
    kb = xbmc.Keyboard(heading='Search')
    kb.doModal()
    if not kb.isConfirmed():
        return
    ret = haitum.search(kb.getText())
    if 'code' in ret:
        xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
        return
    for elem in ret['item']:
        item(elem['title'], elem)
    xbmcplugin.endOfDirectory(handle)


def get_node(url):
    try:
        content = requests.get(url).text
    except:
        xbmcgui.Dialog().ok('错误', '错误代码: haitum 010')
        return
    sub3(content)


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    item('电影', {'category': 'dianying', 'page': 1})
    item('电视剧', {'category': 'dianshiju', 'page': 1})
    item('综艺', {'category': 'zongyi', 'page': 1})
    item('动漫', {'category': 'dongman', 'page': 1})
    item('纪录片', {'category': 'jilupian', 'page': 1})
    item('微电影', {'category': 'weidianying', 'page': 1})
    item('Search', {'search': True})
    get_node('http://ims.tian-le.com/haitum.json')
else:
    o = urlparse(url)
    q = parse_qs(o.query)
    if 'json' in q:
        sub3(q['json'][0])
    if 'category' in q:
        category(q['category'][0], int(q['page'][0]))
    if 'search' in q:
        search()
    if 'url' in q:
        sub2(q['url'][0])
